'use strict';

exports.__esModule = true;
exports.default = onFirstBlur;

var _utils = require('../utils');

var utils = _interopRequireWildcard(_utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function onFirstBlur(context, field, data, statuses, event) {
  if (!event || event.type === 'blur') {
    var validationState = utils.normalizeValidationResults(field.validate, data.value, context.props);

    if (!validationState.valid) {
      validationState.status = validationState.status || statuses.error;
    } else if (data.value) {
      validationState.status = validationState.status || statuses.success;
    }

    context.setBluredField(data.fieldId);

    return validationState;
  }

  return {};
}