'use strict';

exports.__esModule = true;
exports.getStrategy = getStrategy;

var _utils = require('../utils');

var utils = _interopRequireWildcard(_utils);

var _FeedbackStrategy = require('../enums/FeedbackStrategy');

var _FeedbackStrategy2 = _interopRequireDefault(_FeedbackStrategy);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function getStrategy(context, field) {
  var props = context.props;
  var INSTANT = _FeedbackStrategy2.default.INSTANT,
      INSTANT_TOUCHED_ONLY = _FeedbackStrategy2.default.INSTANT_TOUCHED_ONLY,
      ON_CHANGE = _FeedbackStrategy2.default.ON_CHANGE,
      ON_SUBMIT = _FeedbackStrategy2.default.ON_SUBMIT;


  if ([INSTANT, INSTANT_TOUCHED_ONLY].includes(field.feedbackStrategy)) {
    return field.feedbackStrategy;
  }

  if (!utils.isDefined(field.feedbackStrategy) && [INSTANT, INSTANT_TOUCHED_ONLY].includes(props.feedbackStrategy)) {
    return props.feedbackStrategy;
  }

  if (context.formWasSubmitted) {
    return ON_SUBMIT;
  }

  if (context.bluredFields[field.attr]) {
    return ON_CHANGE;
  }

  return field.feedbackStrategy || props.feedbackStrategy || ON_SUBMIT;
}