'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.parseFieldsFromProps = parseFieldsFromProps;

var _utils = require('../utils');

var utils = _interopRequireWildcard(_utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function parseFieldsFromProps(fields, data) {
  var parsedFields = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var parentKeyPath = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];

  var names = Object.keys(fields);

  var index = -1;
  while (++index < names.length) {
    var name = names[index];
    var fieldsBranch = fields[name];
    var dataBranch = utils.fetchProp(data, name);
    var keyPath = parentKeyPath.concat(name);

    if (utils.isPlainObject(dataBranch)) {
      parseFieldsFromProps(fieldsBranch, dataBranch, parsedFields, keyPath);
    } else {
      var parsedField = utils.isPlainObject(fieldsBranch) ? _extends({ keyPath: keyPath, name: name }, fieldsBranch) : { keyPath: keyPath, name: name };
      parsedFields.push(parsedField);
    }
  }

  return parsedFields;
}